git-stash.sh 8.4 KB
Newer Older
しらいしななこ 已提交
1 2 3
#!/bin/sh
# Copyright (c) 2007, Nanako Shiraishi

4 5
dashless=$(basename "$0" | sed -e 's/-/ /')
USAGE="list [<options>]
S
Stephen Boyd 已提交
6 7 8
   or: $dashless show [<stash>]
   or: $dashless drop [-q|--quiet] [<stash>]
   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9
   or: $dashless branch <branchname> [<stash>]
10
   or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
11
   or: $dashless clear"
しらいしななこ 已提交
12

13
SUBDIRECTORY_OK=Yes
14
OPTIONS_SPEC=
しらいしななこ 已提交
15 16
. git-sh-setup
require_work_tree
17
cd_to_toplevel
しらいしななこ 已提交
18 19 20 21 22 23

TMP="$GIT_DIR/.git-stash.$$"
trap 'rm -f "$TMP-*"' 0

ref_stash=refs/stash

T
Thomas Rast 已提交
24 25 26 27 28 29 30 31
if git config --get-colorbool color.interactive; then
       help_color="$(git config --get-color color.interactive.help 'red bold')"
       reset_color="$(git config --get-color '' reset)"
else
       help_color=
       reset_color=
fi

しらいしななこ 已提交
32
no_changes () {
33 34
	git diff-index --quiet --cached HEAD --ignore-submodules -- &&
	git diff-files --quiet --ignore-submodules
しらいしななこ 已提交
35 36 37
}

clear_stash () {
38 39 40 41
	if test $# != 0
	then
		die "git stash clear with parameters is unimplemented"
	fi
42
	if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
43
	then
E
Emil Medve 已提交
44
		git update-ref -d $ref_stash $current
45
	fi
しらいしななこ 已提交
46 47
}

J
Junio C Hamano 已提交
48
create_stash () {
49 50
	stash_msg="$1"

51
	git update-index -q --refresh
しらいしななこ 已提交
52 53 54 55
	if no_changes
	then
		exit 0
	fi
56

しらいしななこ 已提交
57
	# state of the base commit
58
	if b_commit=$(git rev-parse --verify HEAD)
しらいしななこ 已提交
59
	then
60
		head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
しらいしななこ 已提交
61 62 63 64
	else
		die "You do not have the initial commit yet"
	fi

65
	if branch=$(git symbolic-ref -q HEAD)
しらいしななこ 已提交
66 67 68 69 70 71 72 73
	then
		branch=${branch#refs/heads/}
	else
		branch='(no branch)'
	fi
	msg=$(printf '%s: %s' "$branch" "$head")

	# state of the index
74
	i_tree=$(git write-tree) &&
75
	i_commit=$(printf 'index on %s\n' "$msg" |
76
		git commit-tree $i_tree -p $b_commit) ||
しらいしななこ 已提交
77 78
		die "Cannot save the current index state"

T
Thomas Rast 已提交
79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96
	if test -z "$patch_mode"
	then

		# state of the working tree
		w_tree=$( (
			rm -f "$TMP-index" &&
			cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
			GIT_INDEX_FILE="$TMP-index" &&
			export GIT_INDEX_FILE &&
			git read-tree -m $i_tree &&
			git add -u &&
			git write-tree &&
			rm -f "$TMP-index"
		) ) ||
			die "Cannot save the current worktree state"

	else

97
		rm -f "$TMP-index" &&
T
Thomas Rast 已提交
98 99 100 101 102 103 104 105
		GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&

		# find out what the user wants
		GIT_INDEX_FILE="$TMP-index" \
			git add--interactive --patch=stash -- &&

		# state of the working tree
		w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
しらいしななこ 已提交
106 107
		die "Cannot save the current worktree state"

T
Thomas Rast 已提交
108 109 110 111 112 113 114 115 116
		git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
		test -s "$TMP-patch" ||
		die "No changes selected"

		rm -f "$TMP-index" ||
		die "Cannot remove temporary index (can't happen)"

	fi

しらいしななこ 已提交
117
	# create the stash
118 119 120 121 122 123 124
	if test -z "$stash_msg"
	then
		stash_msg=$(printf 'WIP on %s' "$msg")
	else
		stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
	fi
	w_commit=$(printf '%s\n' "$stash_msg" |
125
		git commit-tree $w_tree -p $b_commit -p $i_commit) ||
しらいしななこ 已提交
126
		die "Cannot record working tree state"
J
Junio C Hamano 已提交
127
}
しらいしななこ 已提交
128

J
Junio C Hamano 已提交
129
save_stash () {
130
	keep_index=
T
Thomas Rast 已提交
131
	patch_mode=
S
Stephen Boyd 已提交
132 133 134
	while test $# != 0
	do
		case "$1" in
135
		-k|--keep-index)
S
Stephen Boyd 已提交
136 137
			keep_index=t
			;;
T
Thomas Rast 已提交
138 139 140 141 142
		--no-keep-index)
			keep_index=
			;;
		-p|--patch)
			patch_mode=t
S
Stephen Boyd 已提交
143 144 145 146 147
			keep_index=t
			;;
		-q|--quiet)
			GIT_QUIET=t
			;;
148 149 150 151 152 153 154 155
		--)
			shift
			break
			;;
		-*)
			echo "error: unknown option for 'stash save': $1"
			usage
			;;
S
Stephen Boyd 已提交
156 157 158 159
		*)
			break
			;;
		esac
160
		shift
S
Stephen Boyd 已提交
161
	done
162

163
	stash_msg="$*"
J
Junio C Hamano 已提交
164

165
	git update-index -q --refresh
J
Junio C Hamano 已提交
166 167
	if no_changes
	then
S
Stephen Boyd 已提交
168
		say 'No local changes to save'
J
Junio C Hamano 已提交
169 170 171 172 173 174
		exit 0
	fi
	test -f "$GIT_DIR/logs/$ref_stash" ||
		clear_stash || die "Cannot initialize stash"

	create_stash "$stash_msg"
E
Emil Medve 已提交
175 176 177

	# Make sure the reflog for stash is kept.
	: >>"$GIT_DIR/logs/$ref_stash"
しらいしななこ 已提交
178

179
	git update-ref -m "$stash_msg" $ref_stash $w_commit ||
しらいしななこ 已提交
180
		die "Cannot save the current status"
S
Stephen Boyd 已提交
181
	say Saved working directory and index state "$stash_msg"
182

T
Thomas Rast 已提交
183
	if test -z "$patch_mode"
184
	then
T
Thomas Rast 已提交
185 186 187 188 189 190 191 192 193 194 195 196 197 198
		git reset --hard ${GIT_QUIET:+-q}

		if test -n "$keep_index" && test -n $i_tree
		then
			git read-tree --reset -u $i_tree
		fi
	else
		git apply -R < "$TMP-patch" ||
		die "Cannot remove worktree changes"

		if test -z "$keep_index"
		then
			git reset
		fi
199
	fi
しらいしななこ 已提交
200 201
}

202
have_stash () {
203
	git rev-parse --verify $ref_stash >/dev/null 2>&1
204 205
}

しらいしななこ 已提交
206
list_stash () {
207
	have_stash || return 0
208
	git log --format="%gd: %gs" -g "$@" $ref_stash --
しらいしななこ 已提交
209 210 211
}

show_stash () {
212
	flags=$(git rev-parse --no-revs --flags "$@")
しらいしななこ 已提交
213 214 215 216
	if test -z "$flags"
	then
		flags=--stat
	fi
217

218 219
	w_commit=$(git rev-parse --verify --default $ref_stash "$@") &&
	b_commit=$(git rev-parse --verify "$w_commit^") &&
220
	git diff $flags $b_commit $w_commit
しらいしななこ 已提交
221 222 223
}

apply_stash () {
224
	unstash_index=
S
Stephen Boyd 已提交
225 226 227 228 229 230 231 232 233 234 235 236 237 238

	while test $# != 0
	do
		case "$1" in
		--index)
			unstash_index=t
			;;
		-q|--quiet)
			GIT_QUIET=t
			;;
		*)
			break
			;;
		esac
239
		shift
S
Stephen Boyd 已提交
240
	done
241

242 243 244 245
	if test $# = 0
	then
		have_stash || die 'Nothing to apply'
	fi
しらいしななこ 已提交
246

J
Junio C Hamano 已提交
247 248
	# stash records the work tree, and is a merge between the
	# base commit (first parent) and the index tree (second parent).
249 250 251 252
	s=$(git rev-parse --quiet --verify --default $ref_stash "$@") &&
	w_tree=$(git rev-parse --quiet --verify "$s:") &&
	b_tree=$(git rev-parse --quiet --verify "$s^1:") &&
	i_tree=$(git rev-parse --quiet --verify "$s^2:") ||
しらいしななこ 已提交
253 254
		die "$*: no valid stashed state found"

255 256 257 258 259 260 261 262
	git update-index -q --refresh &&
	git diff-files --quiet --ignore-submodules ||
		die 'Cannot apply to a dirty working tree, please stage your changes'

	# current index state
	c_tree=$(git write-tree) ||
		die 'Cannot apply a stash in the middle of a merge'

J
Junio C Hamano 已提交
263
	unstashed_index_tree=
264 265
	if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
			test "$c_tree" != "$i_tree"
J
Junio C Hamano 已提交
266
	then
267
		git diff-tree --binary $s^2^..$s^2 | git apply --cached
268 269
		test $? -ne 0 &&
			die 'Conflicts in index. Try without --index.'
270
		unstashed_index_tree=$(git write-tree) ||
271 272
			die 'Could not save index tree'
		git reset
J
Junio C Hamano 已提交
273
	fi
274

しらいしななこ 已提交
275 276 277 278 279 280 281
	eval "
		GITHEAD_$w_tree='Stashed changes' &&
		GITHEAD_$c_tree='Updated upstream' &&
		GITHEAD_$b_tree='Version stash was based on' &&
		export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
	"

S
Stephen Boyd 已提交
282 283 284 285
	if test -n "$GIT_QUIET"
	then
		export GIT_MERGE_VERBOSITY=0
	fi
286
	if git merge-recursive $b_tree -- $c_tree $w_tree
しらいしななこ 已提交
287 288
	then
		# No conflict
J
Junio C Hamano 已提交
289 290 291
		if test -n "$unstashed_index_tree"
		then
			git read-tree "$unstashed_index_tree"
292 293
		else
			a="$TMP-added" &&
294
			git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
295 296 297 298
			git read-tree --reset $c_tree &&
			git update-index --add --stdin <"$a" ||
				die "Cannot unstage modified files"
			rm -f "$a"
J
Junio C Hamano 已提交
299
		fi
S
Stephen Boyd 已提交
300 301 302 303 304 305
		squelch=
		if test -n "$GIT_QUIET"
		then
			squelch='>/dev/null 2>&1'
		fi
		eval "git status $squelch" || :
しらいしななこ 已提交
306 307
	else
		# Merge conflict; keep the exit status from merge-recursive
308
		status=$?
J
Junio C Hamano 已提交
309 310 311 312
		if test -n "$unstash_index"
		then
			echo >&2 'Index was not unstashed.'
		fi
313
		exit $status
しらいしななこ 已提交
314 315 316
	fi
}

317 318 319
drop_stash () {
	have_stash || die 'No stash entries to drop'

S
Stephen Boyd 已提交
320 321 322 323 324 325 326 327 328 329 330 331 332
	while test $# != 0
	do
		case "$1" in
		-q|--quiet)
			GIT_QUIET=t
			;;
		*)
			break
			;;
		esac
		shift
	done

333 334 335 336 337 338
	if test $# = 0
	then
		set x "$ref_stash@{0}"
		shift
	fi
	# Verify supplied argument looks like a stash entry
339
	s=$(git rev-parse --verify "$@") &&
340 341 342
	git rev-parse --verify "$s:"   > /dev/null 2>&1 &&
	git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
	git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
343 344 345
		die "$*: not a valid stashed state"

	git reflog delete --updateref --rewrite "$@" &&
S
Stephen Boyd 已提交
346
		say "Dropped $* ($s)" || die "$*: Could not drop stash entry"
347 348

	# clear_stash if we just dropped the last stash entry
349
	git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
350 351
}

352 353 354 355 356 357 358 359 360 361 362 363
apply_to_branch () {
	have_stash || die 'Nothing to apply'

	test -n "$1" || die 'No branch name specified'
	branch=$1

	if test -z "$2"
	then
		set x "$ref_stash@{0}"
	fi
	stash=$2

364
	git checkout -b $branch $stash^ &&
365 366 367 368
	apply_stash --index $stash &&
	drop_stash $stash
}

369 370 371 372 373 374 375 376 377 378 379 380
# The default command is "save" if nothing but options are given
seen_non_option=
for opt
do
	case "$opt" in
	-*) ;;
	*) seen_non_option=t; break ;;
	esac
done

test -n "$seen_non_option" || set "save" "$@"

しらいしななこ 已提交
381 382
# Main command set
case "$1" in
383 384
list)
	shift
しらいしななこ 已提交
385 386 387 388 389 390
	list_stash "$@"
	;;
show)
	shift
	show_stash "$@"
	;;
391 392
save)
	shift
393
	save_stash "$@"
394
	;;
しらいしななこ 已提交
395 396 397 398 399
apply)
	shift
	apply_stash "$@"
	;;
clear)
400 401
	shift
	clear_stash "$@"
しらいしななこ 已提交
402
	;;
J
Junio C Hamano 已提交
403 404 405 406 407 408 409
create)
	if test $# -gt 0 && test "$1" = create
	then
		shift
	fi
	create_stash "$*" && echo "$w_commit"
	;;
410 411 412 413
drop)
	shift
	drop_stash "$@"
	;;
414 415 416 417 418 419 420 421
pop)
	shift
	if apply_stash "$@"
	then
		test -z "$unstash_index" || shift
		drop_stash "$@"
	fi
	;;
422 423 424 425
branch)
	shift
	apply_to_branch "$@"
	;;
しらいしななこ 已提交
426
*)
427 428
	case $# in
	0)
429
		save_stash &&
S
Stephen Boyd 已提交
430
		say '(To restore them type "git stash apply")'
431 432
		;;
	*)
433
		usage
434
	esac
435
	;;
しらいしななこ 已提交
436
esac